using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Serialization;

namespace CheesyFX
{
    public class Penetrator : MonoBehaviour
    {
        public int type;
        public Transform tip;
        public Rigidbody root;
        public Transform rootTransform;
        public Collider tipCollider;
        public List<Collider> colliders = new List<Collider>();
        public Atom atom;
        public float scale;
        public float width;
        public ScaleChangeReceiver scaleChangeReceiver;
        public Func<Vector3> forward;

        public Penetrator Init(Collider collider)
        {
            this.tipCollider = collider;
            atom = collider.GetAtom();
            tip = new GameObject().transform;
            tip.SetParent(this.tipCollider.transform, false);
            enabled = false;
            scaleChangeReceiver = atom.scaleChangeReceivers[0];
            scale = scaleChangeReceiver.scale;
            return this;
        }

        // public virtual void Update()
        // {
        // }
    }
}